%% Přednáška 5

%% Snížení barevné hloubky
% Nahodné rozptylování
% zpracování prvek po prvku

f = rgb2gray(imread('pastelky.png'));

f_max = max(max(f));

g = uint8(zeros(size(f,1),size(f,2)));

for i = 1 : size(f,1)
    for j = 1 : size(f,2)
        % randi vrati nahodne cislo
        r = randi(f_max);
        if f(i,j) > r
            g(i,j) = g(i,j) +1;
        end
    end
end

figure
subplot(1,2,1)
imshow(f,[])
subplot(1,2,2)
imshow(g,[]);

%% 
% zpracování pomocí maticových operací

f = rgb2gray(imread('pastelky.png'));
[m,n] = size(f);
f_max = max(max(f));
g = uint8(zeros(size(f,1),size(f,2)));

g = g + uint8(f >= randi(f_max,[m,n]));
figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);

%% Špatný přístup
% porovnávají se všechny pixely se stejnou hodnotou.

f = rgb2gray(imread('pastelky.png'));
[m,n] = size(f);
f_max = max(max(f));
g = uint8(zeros(size(f,1),size(f,2)));

g = (f >= randi(f_max)); 

figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);

%% Maticové rozptylování
% Zvětšení velikosti obrazu


f = rgb2gray(imread('pastelky.png'));
[ g ] = matrix_dithering( f );

figure
subplot(1,2,1)
imshow(f(100:300,100:300),[]);
subplot(1,2,2)
imshow(g(200:600,200:600),[]);

%% Nevhodně zvolené matice

f = rgb2gray(imread('pastelky.png'));
[ g ] = matrix_dithering2( f );

figure
subplot(1,2,1)
imshow(f(100:300,100:300),[]);
subplot(1,2,2)
imshow(g(200:600,200:600),[]);

%% Maticové rozptylování se zachováním velikosti

f = rgb2gray(imread('pastelky.png'));
[ g ] = matrix_dithering3( f );

figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);

%% Rozptylování s distribucí chyby
% Floyd Steinberg

f = rgb2gray(imread('pastelky.png'));
g = floyd_steinberg( f );

figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);
%% Barevné obrázky
% Náhodné

f = imread('pastelky.png');
[m,n,o] = size(f);
f_red = f(:,:,1);
f_green = f(:,:,2);
f_blue = f(:,:,3);

% červená složka
f_max_r = max(max(f_red));
g_red = uint8(zeros(m,n));
g_red = g_red + uint8(f_red >= randi(f_max_r,[m,n]));

% zelená složka
f_max_g = max(max(f_green));
g_green = uint8(zeros(m,n));
g_green = g_green + uint8(f_green >= randi(f_max_g,[m,n]));

% modrá složka
f_max_b = max(max(f_blue));
g_blue = uint8(zeros(m,n));
g_blue = g_blue + uint8(f_blue >= randi(f_max_b,[m,n]));

g=[];
g(:,:,1) = g_red;
g(:,:,2) = g_green;
g(:,:,3) = g_blue;

figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);

%%
% Maticové

f = imread('pastelky.png');
[m,n,o] = size(f);
f_red = f(:,:,1);
f_green = f(:,:,2);
f_blue = f(:,:,3);

g_red = matrix_dithering3( f_red );
g_green = matrix_dithering3( f_green );
g_blue = matrix_dithering3( f_blue );

g=[];
g(:,:,1) = g_red;
g(:,:,2) = g_green;
g(:,:,3) = g_blue;

figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);

%% 
% s distribucí chyby
f = imread('pastelky.png');
[m,n,o] = size(f);
f_red = f(:,:,1);
f_green = f(:,:,2);
f_blue = f(:,:,3);

g_red = floyd_steinberg( f_red );
g_green = floyd_steinberg( f_green );
g_blue = floyd_steinberg( f_blue );

g=[];
g(:,:,1) = g_red;
g(:,:,2) = g_green;
g(:,:,3) = g_blue;

figure
subplot(1,2,1)
imshow(f,[]);
subplot(1,2,2)
imshow(g,[]);

%% barevna paleta
f = imread('pastelky2.png');
tol = 1/3;
[x1,map1] = rgb2ind(f, tol, 'nodither');
[x2,map2] = rgb2ind(f, 64, 'nodither');

subplot(1,3,1), imshow(f);
subplot(1,3,2), imshow(x1,map1);
subplot(1,3,3), imshow(x2,map2);
%%
subplot(2,1,1), imshow((cat(3, map1(:,1)',map1(:,2)', map1(:,3)')));
title("Univerzalni");
subplot(2,1,2), imshow((cat(3, map2(:,1)',map2(:,2)', map2(:,3)')));
title("Adaptivni");


%% Všechny barvy
f = imread('allcolor.png');
tol = 1/3;
[x1,map3] = rgb2ind(f, tol, 'nodither');
[x2,map4] = rgb2ind(f, 64, 'nodither');

subplot(1,3,1), imshow(f);
subplot(1,3,2), imshow(x1,map3);
subplot(1,3,3), imshow(x2,map4);

%%
subplot(2,1,1), imshow((cat(3, map3(:,1)',map3(:,2)', map3(:,3)')));
title("Univerzalni");
subplot(2,1,2), imshow((cat(3, map4(:,1)',map4(:,2)', map4(:,3)')));
title("Adaptivni");

